rgb_delay	equ	8

check_top_palette
	moveq.l	#0,d0
	move.b	ypos,d0
	cmp.w	#110,d0
	blt.s	.okay
	rts
.okay	btst	#6,$bfe001
	bne.s	.out
.wait	btst	#6,$bfe001
	beq.s	.wait
	moveq.l	#0,d0
	move.w	xpos,d0
	lsr.w	#3,d0
	move.w	d0,edittopX
	moveq.l	#1,d2
	bsr	get_ypos
	move.w	d2,d1
	move.w	d2,edittopY
	mulu	#40,d1
	add.w	d0,d1
	move.w	d1,edittopcol
	cmp.w	#256,edittopcol
	bge.s	.out
	bsr	undrawtopbox
	bsr	drawtopbox
	bsr	print_edit_rgb
.out	rts

;---------------------------------------------
check_bottom_palette
	moveq.l	#0,d0
	move.b	ypos,d0
	cmp.w	#110,d0
	blt.s	.out
	cmp.w	#200,d0
	blt.s	.okay
.out	rts
.okay	btst	#6,$bfe001
	bne.s	.right
	move.w	#1,fuckcol
	bra.s	.doit	
.right	btst	#10,$dff016
	bne.s	.out
	move.w	#0,fuckcol
.doit	moveq.l	#0,d0
	move.w	xpos,d0
	lsr.w	#3,d0
	move.w	d0,editbotX
	move.l	#110,d2
	bsr	get_ypos
	move.w	d2,d1
	move.w	d2,editbotY
	mulu	#40,d1
	add.w	d0,d1
	move.w	d1,editbotcol
	cmp.w	#256,editbotcol
	bge.s	.out2
	bsr	drawbotbox	
	bsr	print_bottom_select_rgb
.out2	rts

;---------------------------------------------
drawtopbox	move.l	editscreenB,a0
	moveq.l	#0,d0
	move.w	edittopY,d0
	mulu	#12,d0
	add.w	#10,d0
	mulu	#40*8,d0
	add.l	d0,a0
	move.w	edittopX,d0
	add.w	d0,a0
	move.b	#$7f,(a0)
	move.b	#$7f,320(a0)
	move.w	edittopX,oldedittopX
	move.w	edittopY,oldedittopY
	rts
;---------------------------------------------
undrawtopbox
	move.l	editscreenB,a0
	moveq.l	#0,d0
	move.w	oldedittopY,d0
	mulu	#12,d0
	add.w	#10,d0
	mulu	#40*8,d0
	add.l	d0,a0
	move.w	oldedittopX,d0
	add.w	d0,a0
	move.b	#0,(a0)
	move.b	#0,320(a0)
	rts
;---------------------------------------------
drawbotbox
	move.l	editscreenB,a0
	moveq.l	#0,d0
	move.w	editbotY,d0
	mulu	#12,d0
	add.w	#110+09,d0
	mulu	#40*8,d0
	add.l	d0,a0
	move.w	editbotX,d0
	add.w	d0,a0
	lea	palbottom_table,a2
	move.w	editbotcol,d0
	tst.w	fuckcol
	beq.s	.clear
	move.b	#$7f,(a0)
	move.b	#$7f,320(a0)
	move.w	#1,(a2,d0.w*2)	
	rts
.clear	move.b	#0,(a0)
	move.b	#0,320(a0)
	move.w	#0,(a2,d0.w*2)
	rts
;---------------------------------------------
get_ypos	moveq.l	#0,d1
	move.b	ypos,d1
	sub.l	d2,d1
	moveq.l	#0,d2
.loop	sub.l	#12,d1
	tst.l	d1
	bmi.s	.out
	beq.s	.out
	addq.w	#1,d2		
	bra.s	.loop
.out	rts
;---------------------------------------------
init_palettelist
	move.w	#0,palettes
	move.l	#4*512,d0
	move.l	#$10001,d1
	LIB	allocmem,exec
	move.l	d0,palette_list
	move.l	d0,a0
	move.l	#512-1,d7
.loop	move.l	#-1,(a0)+
	dbra	d7,.loop
	rts
;---------------------------------------------
free_palettelist
	move.l	palette_list,a6
.loop	cmp.l	#-1,(a6)
	beq.s	.next
	move.l	(a6)+,a1
	move.l	#$300,d0			; palette size
	LIB	freemem,exec
	bra.s	.loop
.next	move.l	palette_list,a1
	move.l	#4*512,d0
	LIB	freemem,exec
	rts
;---------------------------------------------
free_palettelist_generic
	move.l	palette_list,a6
.loop	cmp.l	#-1,(a6)
	beq.s	.next
	move.l	(a6),a1
	move.l	#-1,(a6)+
	move.l	#$300,d0			; palette size
	LIB	freemem,exec
	bra.s	.loop
.next	rts
;---------------------------------------------
find_free_palettelist
	move.l	#511-1,d7
	move.l	palette_list,a6
.loop	cmp.l	#-1,(a6)
	beq.s	.found
	addq.l	#4,a6
	dbra	d7,.loop
	move.w	#12,status_mode
	moveq.l	#-1,d7
	rts
.found	move.w	#0,status_mode
	moveq.l	#0,d7
	rts
;---------------------------------------------
alloc_palette
	bsr	find_free_palettelist
	tst.l	d7
	bmi	.error
	move.l	#$300,d0			; palette size
	move.l	#$10001,d1
	LIB	allocmem,exec
	tst.l	d0
	beq.s	.error2
	move.l	d0,(a6)			; store palette
	move.l	#-1,4(a6)			; set end
	move.l	d0,a0
	lea	iff_palette,a1
	move.l	#$300-1,d7
.loop	move.b	(a1)+,(a0)+
	dbra	d7,.loop
	add.w	#1,palettes
	moveq.l	#0,d7
	rts
.error2	move.w	#13,status_mode
.error	moveq.l	#-1,d7
	rts
;---------------------------------------------
draw_palette_boxs
	moveq.l	#0,d2
	moveq.l	#1,d1
	moveq.l	#6-1,d6
.mloop	movem.l	d1/d2/d6,-(sp)
	moveq.l	#0,d0
	moveq.l	#40-1,d7
.loop	bsr	drawpalettebox
	addq.w	#1,d0
	addq.w	#1,d2
	dbra	d7,.loop
	movem.l	(sp)+,d1/d2/d6
	add.l	#40,d2
	add.l	#12,d1
	dbra	d6,.mloop

	move.l	#240,d2
	move.l	#12*6+1,d1
	moveq.l	#0,d0
	moveq.l	#16-1,d7
.loop2	bsr	drawpalettebox
	addq.w	#1,d0
	addq.w	#1,d2
	dbra	d7,.loop2
drawbottom
	moveq.l	#0,d2
	move.l	#110,d1
	moveq.l	#6-1,d6
.mloop	movem.l	d1/d2/d6,-(sp)
	moveq.l	#0,d0
	moveq.l	#40-1,d7
.loop	bsr	drawpalettebox
	addq.w	#1,d0
	addq.w	#1,d2
	dbra	d7,.loop
	movem.l	(sp)+,d1/d2/d6
	add.l	#40,d2
	add.l	#12,d1
	dbra	d6,.mloop

	move.l	#240,d2
	move.l	#110+12*6,d1
	moveq.l	#0,d0
	moveq.l	#16-1,d7
.loop2	bsr	drawpalettebox
	addq.w	#1,d0
	addq.w	#1,d2
	dbra	d7,.loop2
	rts			
;---------------------------------------------
drawpalettebox
	movem.l	d0-d7/a0-a6,-(sp)
	ext.l	d0
	ext.l	d1
	move.l	editscreenB,a0
	mulu.l	#40*8,d1
	add.l	d0,d1
	add.l	d1,a0	
	moveq.l	#8-1,d7
	moveq.l	#0,d6
.loop	btst	d6,d2
	beq.s	.next
	move.l	a0,a1
	moveq.l	#8-1,d5
.loop1	move.b	#$7f,(a1)
	add.l	#40*8,a1
	dbra	d5,.loop1		
.next	addq.l	#1,d6
	add.l	#40,a0
	dbra	d7,.loop
	movem.l	(sp)+,d0-d7/a0-a6
	rts
;---------------------------------------------
do_edit_palette
	move.w	#-1,editpal
	move.l	sprite_list,a6
.sloop	cmp.l	#-1,(a6)
	beq.s	.next
	move.l	(a6),a1
	cmp.w	#1,spr_mode(a1)
	bne.s	.nextspr
	move.w	spr_palette(a1),editpal
	bra.s	.next
.nextspr	addq.l	#4,a6
	bra.s	.sloop
		
.next
do_edit_palette2
	move.w	editpal,d0
	cmp.w	#-1,d0
	bne	.ass
	move.w	#0,editpal
	moveq.l	#0,d0
.ass	move.l	palette_list,a0
	beq	.out
	move.l	(a0,d0.w*4),a0
	cmp.l	#-1,(a0)
	beq	.out

	lea	palette_colours2,a2
	lea	palette_colours_lo2,a1
	move.w	#0,bodgetest
	moveq.l	#8-1,d7
.loop	addq.l	#4,a1
	addq.l	#4,a2
	move.l	#32-1,d6
.loop1	bsr	make_colour
	move.w	d0,2(a1)
	swap	d0
	move.w	d0,2(a2)
	cmp.w	#0,bodgetest
	bne.s	.past
	move.w	d0,bodgecol+2
	move.w	#1,bodgetest
.past	addq.l	#4,a1
	addq.l	#4,a2
	dbra	d6,.loop1
	dbra	d7,.loop		
	bsr	print_edit_palette_number
.out	rts
;---------------------------------------------
do_buffer_palette
	lea	buffer_palette,a0
	lea	palette_colours,a2
	lea	palette_colours_lo,a1
	moveq.l	#8-1,d7
.loop	addq.l	#4,a1
	addq.l	#4,a2
	move.l	#32-1,d6
.loop1	bsr	make_colour
	move.w	d0,2(a1)
	swap	d0
	move.w	d0,2(a2)
	addq.l	#4,a1
	addq.l	#4,a2
	dbra	d6,.loop1
	dbra	d7,.loop		
	rts
;---------------------------------------------
load_palettes
	bsr	do_icon
	lea	palloadtxt,a0
	lea	load_palettes_routine,a1
	lea	palonlytxt,a2
	bsr	load_file2
	rts
;---------------------------------------------
load_palettes_routine
	move.l	#4,file_length
	move.l	#palcheckheader,file_address
	bsr	read_stuff2
	cmp.l	#'PALL',palcheckheader
	bne	.error
	bsr	free_palettelist_generic
	move.l	#2,file_length
	move.l	#palettes,file_address
	bsr	read_stuff2
	move.w	palettes,d7
	subq.w	#1,d7

.loop	move.l	d7,-(sp)
	bsr	find_free_palettelist
;---------------------------------------------
	move.l	#$300,d0
	move.l	#$10001,d1
	LIB	allocmem,exec
	move.l	d0,file_address
	move.l	d0,(a6)
;---------------------------------------------
	move.l	#$300,file_length
	bsr	read_stuff2
	move.l	(sp)+,d7
	dbra	d7,.loop	
	move.w	#0,status_mode
.error2	bsr	do_status
.error	rts
;---------------------------------------------
save_palettes
	bsr	do_icon
	lea	palsavetxt,a0
	lea	save_palettes_routine,a1
	lea	palonlytxt,a2
	bsr	save_file
	rts
;---------------------------------------------
save_palettes_routine
	cmp.w	#0,palettes
	beq.s	.out
	move.l	#4,file_length
	move.l	#palheader,file_address
	bsr	write_stuff
;---------------------------------------------
	move.l	#palettes,file_address
	move.l	#2,file_length
	bsr	write_stuff
;---------------------------------------------
	move.w	palettes,d7
	subq.w	#1,d7
	move.l	palette_list,a6
.loop	move.l	(a6)+,file_address
	move.l	#$300,file_length
	move.l	d7,-(sp)
	bsr	write_stuff
	move.l	(sp)+,d7
	dbra	d7,.loop
.out	rts

palheader		dc.b	'PALL'
;---------------------------------------------
load_buffer_palette
	bsr	do_icon
	lea	loadbuftxt,a0
	lea	load_buffer_palette_routine,a1
	lea	bufonlytxt,a2	
	bsr	load_file2
	rts
;---------------------------------------------
load_buffer_palette_routine
	move.l	#$300,file_length
	move.l	#buffer_palette,file_address
	bsr	read_stuff2
	bsr	do_buffer_palette
	rts
;---------------------------------------------
save_buffer_palette
	bsr	do_icon
	lea	savebuftxt,a0
	lea	save_buffer_palette_routine,a1
	lea	bufonlytxt,a2
	bsr	save_file
	rts
;---------------------------------------------
save_buffer_palette_routine
	move.l	#$300,file_length
	move.l	#buffer_palette,file_address
	bsr	write_stuff
	bsr	do_buffer_palette
	rts
;---------------------------------------------
clear_buffer_palette
	bsr	do_icon
	lea	buffer_palette,a0
	move.b	#$00,(a0)+
	move.b	#$00,(a0)+
	move.b	#$ff,(a0)+
	move.l	#255-1,d7
.loop	move.b	#$00,(a0)+
	move.b	#$ff,(a0)+
	move.b	#$00,(a0)+
	dbra	d7,.loop
	bsr	do_buffer_palette
	move.w	#0,status_mode
	bsr	do_status
	rts
;---------------------------------------------
print_number_palettes
	move.l	#1,tcol
	move.l	#11,d0
	move.l	#32,d1
	moveq.l	#3,d3
	moveq.l	#0,d2
	move.w	palettes,d2
	bsr	dec_print
	rts
;---------------------------------------------
copy_colours
	bsr	do_icon
	moveq.l	#0,d0
	move.w	edittopcol,d0
	move.w	d0,d5
	lea	buffer_palette,a0
	mulu	#3,d0
	add.l	d0,a0		; buffer palette start

	move.w	editpal,d0
	move.l	palette_list,a2
	move.l	(a2,d0.w*4),a2
	lea	palbottom_table,a1
;---------------------------------------------
	move.l	#256-1,d7
.loop	cmp.w	#0,(a1)
	beq.s	.next
	move.b	(a2),d0
	move.b	1(a2),d1
	move.b	2(a2),d2
	tst.w	check_on
	beq.s	.nocheck
	bsr	check_colour
	tst.l	d6
	bmi.s	.next
.nocheck	move.b	d0,(a0)+
	move.b	d1,(a0)+
	move.b	d2,(a0)+
	add.w	#1,d5
	cmp.w	#256,d5
	bge.s	.out				
.next	lea	2(a1),a1
	lea	3(a2),a2
	dbra	d7,.loop
;---------------------------------------------
.out	bsr	do_buffer_palette
	move.w	#0,status_mode
	bsr	do_status
	rts
;---------------------------------------------
check_colour
	move.w	d5,d6
	tst.w	d6
	beq.s	.past
	subq.w	#1,d6
.past	lea	buffer_palette,a3
.loop	cmp.b	(a3),d0
	bne.s	.next
	cmp.b	1(a3),d1
	bne.s	.next
	cmp.b	2(a3),d2
	bne.s	.next
	moveq.l	#-1,d6
	rts
.next	addq.l	#3,a3
	dbra	d6,.loop
	moveq.l	#0,d6
	rts
;---------------------------------------------
get_used_colours
	bsr	do_icon
	bsr	selected_none
	move.w	#21,status_mode
	move.l	sprite_list,a6
.loop	cmp.l	#-1,(a6)
	beq	.out
	move.w	editpal,d0
	move.l	(a6),a1
	cmp.w	#1,spr_mode(a1)
	bne.s	.next
	cmp.w	spr_palette(a1),d0
	beq.s	.okay_check
.next	addq.l	#4,a6
	bra	.loop
;---------------------------------------------
.okay_check
	lea	spr_varsize(a1),a0
	move.l	spr_size(a1),d0
	sub.l	#spr_varsize,d0
	sub.l	#1,d0
.cloop	moveq.l	#0,d1
	move.b	(a0)+,d1
	and.w	#$ff,d1
	lea	palbottom_table,a2
	move.w	#1,(a2,d1.w*2)
	dbra	d0,.cloop

	move.w	#0,status_mode
	bra	.next
;---------------------------------------------
.out	bsr	print_selected_colours
	bsr	do_status
	rts
;---------------------------------------------
print_selected_colours
	move.l	#7-1,d7
	move.w	#0,editbotY
.yloop	move.w	#0,editbotX
	moveq.l	#40-1,d6
.xloop	bsr	.sel
	add.w	#1,editbotX
	dbra	d6,.xloop		
	add.w	#1,editbotY
	dbra	d7,.yloop
	rts
.sel	move.w	editbotY,d0
	mulu	#40,d0
	add.w	editBotX,d0
	cmp.w	#256,d0
	bge.s	.out
	move.w	d0,editbotcol
	move.l	editscreenB,a0
	moveq.l	#0,d0
	move.w	editbotY,d0
	mulu	#12,d0
	add.w	#110+09,d0
	mulu	#40*8,d0
	add.l	d0,a0
	move.w	editbotX,d0
	add.w	d0,a0
	lea	palbottom_table,a2
	move.w	editbotcol,d0
	and.w	#$ff,d0
	cmp.w	#1,(a2,d0.w*2)
	bne.s	.clear
	move.b	#$7f,(a0)
	move.b	#$7f,320(a0)
.out	rts
.clear	move.b	#0,(a0)
	move.b	#0,320(a0)
	rts
;---------------------------------------------
select_all_colours
	bsr	do_icon
	lea	palbottom_table,a0
	move.l	#256-1,d7
.loop	move.w	#1,(a0)+
	dbra	d7,.loop
	bsr	print_selected_colours
	rts
;---------------------------------------------
select_no_colours
	bsr	do_icon
selected_none
	lea	palbottom_table,a0
	move.l	#256-1,d7
.loop	move.w	#0,(a0)+
	dbra	d7,.loop
	bsr	print_selected_colours
	rts
;---------------------------------------------
check_colours
	bsr	do_icon
	move.w	check_on,d0
	eor.w	#1,d0
	move.w	d0,check_on
print_check_colours
	move.w	check_on,d0
	mulu	#6,d0
	move.l	#1,tcol
	lea	checktxt,a0
	lea	(a0,d0.w),a0
	bsr	print
	rts
check_on	dc.w	0
;---------------------------------------------
previous_palette
	bsr	do_icon
	move.w	editpal,d0
	cmp.w	#0,d0
	beq.s	.out
	sub.w	#1,d0
	move.w	d0,editpal
	move.w	#0,status_mode
	bsr	do_status
	bsr	do_edit_palette2
	bsr	selected_none
	rts
.out	move.w	#23,status_mode
	bsr	do_status
	rts
;---------------------------------------------
next_palette
	bsr	do_icon
	move.w	editpal,d0
	move.w	palettes,d1
	subq.w	#1,d1
	sub.w	d0,d1
	beq.s	.out
	bmi.s	.out
	add.w	#1,d0
	move.w	d0,editpal
	move.w	#0,status_mode
	bsr	do_status
	bsr	do_edit_palette2
	bsr	selected_none
	rts
.out	move.w	#24,status_mode
	bsr	do_status
	rts
;---------------------------------------------
print_edit_palette_number
	move.l	#1,tcol
	move.l	#12,d1
	move.l	#75,d0
	moveq.l	#4,d3
	moveq.l	#0,d2
	move.w	editpal,d2
	addq.w	#1,d2
	bsr	dec_print
	rts
;---------------------------------------------
find_remap_colour_table
	move.w	remap_pal2,d0
	cmp.w	remap_palette,d0
	beq	.out
	movem.l	d0-d7/a0-a6,-(sp)
	move.w	remap_palette,d0
	move.l	palette_list,a6
	move.l	(a6,d0.w*4),a1
	lea	remap_colour_table,a0
	move.l	#256-1,d7
.loop	moveq.l	#0,d0
	moveq.l	#0,d1
	moveq.l	#0,d2
	move.b	(a1)+,d0
	move.b	(a1)+,d1
	move.b	(a1)+,d2
	bsr	.find_colour
	tst.l	d6
	bpl.s	.found
;---------------------------------------------
	movem.l	d7/a0/a1,-(sp)
	bsr	find_color_value
	movem.l	(sp)+,d7/a0/a1
	move.l	foundcolor,d5
;---------------------------------------------
.found	move.b	d5,(a0)+
	dbra	d7,.loop
	movem.l	(sp)+,d0-d7/a0-a6
	move.w	remap_palette,remap_pal2
	tst.w	transcol
	beq.s	.out
	move.b	#0,remap_colour_table
.out	rts
;---------------------------------------------
.find_colour
	lea	buffer_palette,a2
	move.l	#256-1,d3
	moveq.l	#0,d5
.cloop	cmp.b	(a2),d0
	bne.s	.next
	cmp.b	1(a2),d1
	bne.s	.next
	cmp.b	2(a2),d2
	bne.s	.next
	moveq.l	#0,d6
	rts
.next	addq.l	#1,d5
	addq.l	#3,a2
	dbra	d3,.cloop
	moveq.l	#-1,d6
	rts
;---------------------------------------------
remap_sprite_gfx
	movem.l	d0-d7/a0-a6,-(sp)
	move.l	spr_size(a1),d7
	sub.l	#spr_varsize,d7
;;	subq.w	#1,d7
	lea	spr_varsize(a1),a2
	lea	remap_colour_table,a3
.loop	moveq.l	#0,d0
	move.b	(a2),d0
	move.b	(a3,d0.w),(a2)+
	sub.l	#1,d7
	bne.s	.loop
;	dbra	d7,.loop		
.out	movem.l	(sp)+,d0-d7/a0-a6
	rts
;---------------------------------------------
findcolor	equ	-1008

create_colour_table
	lea	buffer_palette,a0
.pas	lea	colortable,a1
	lea	colortable2,a2
	move.l	#256-1,d7
.loop	bsr	make_colour
	move.w	d0,(a2)
	swap	d0
	move.w	d0,(a1)
	addq.l	#2,a1
	addq.l	#2,a2
	dbra	d7,.loop
	rts
;---------------------------------------------
find_color_value
	move.b	d0,red
	move.b	d1,green
	move.b	d2,blue
	lea	colorstructure,a3
	move.l	red,d1
	move.l	green,d2
	move.l	blue,d3
	move.l	#256,d4
	LIB	findcolor,graphics
	move.l	d0,foundcolor
	rts
;---------------------------------------------
colorstructure
	dc.b	1
	dc.b	2
	dc.w	255
	dc.l	colortable
	dc.l	0
	dc.l	colortable2
	dc.b	0,0,0,0
	dc.l	0,0,0,0,0
	dc.w	0,0,0,0
;---------------------------------------------
foundcolor	dc.l	0
red	dc.l	$00ffffff
green	dc.l	$00ffffff
blue	dc.l	$00ffffff
transcol	dc.w	0
;---------------------------------------------
transcol_routine
	bsr	do_icon
	move.w	transcol,d0
	eor.w	#1,d0
	move.w	d0,transcol
print_transcol
	move.l	#1,tcol
	move.w	transcol,d0
	lea	transtxt,a0
	mulu	#6,d0
	lea	(a0,d0.w),a0
	bsr	print
	rts
;---------------------------------------------
print_edit_rgb
	lea	buffer_palette,a0
	move.w	edittopcol,d0
	mulu	#3,d0
	moveq.l	#0,d1
	moveq.l	#0,d2
	moveq.l	#0,d3
	move.b	(a0,d0.w),d1
	move.b	1(a0,d0.w),d2
	move.b	2(a0,d0.w),d3
	move.w	d1,buffer_red
	move.w	d2,buffer_green
	move.w	d3,buffer_blue
	lsr.w	#2,d1
	add.w	#201,d1
	move.w	d1,red_palette_sprite+4
	lsr.w	#2,d2
	add.w	#201,d2
	move.w	d2,green_palette_sprite+4
	lsr.w	#2,d3
	add.w	#201,d3
	move.w	d3,blue_palette_sprite+4
	move.l	#1,tcol
	bsr	do_red_stuff
	bsr	do_green_stuff	
	bsr	do_blue_stuff
	rts

set_palette_rgb
	bclr.b	#2,3(a0)
	bclr.b	#1,3(a0)
	move.b	#$80,d1
	move.w	2(a1),d0
	add.b	#$2c,d0
	bcc	.lp
	bset.l	#2,d1
	bset.l	#1,d1
.lp	move.b	d0,(a0)
	add.b	#7,d0
	bcc	.lp3
	bset.l	#1,d1
.lp3	move.b	d0,2(a0)
.lp2	move.b	d1,3(a0)
	move.w	(a1),d0
	add.w	#$80,d0
	btst.l	#0,d0
	beq	.nolsb
	or.b	#1,3(a0)
.nolsb	lsr.w	#1,d0
	move.b	d0,1(a0)
	rts
;---------------------------------------------
set_buffer_newcol
	lea	buffer_palette,a0
	move.w	edittopcol,d0
	mulu	#3,d0
	moveq.l	#0,d1
	moveq.l	#0,d2
	moveq.l	#0,d3
	move.b	buffer_red+1,(a0,d0.w)
	move.b	buffer_green+1,1(a0,d0.w)
	move.b	buffer_blue+1,2(a0,d0.w)
	bsr	do_buffer_palette
	rts
;---------------------------------------------
do_rgb_red
	cmp.w	#0,menu_sel
	beq.s	.enhance
	move.w	#0,menu_sel
	move.w	#1,pal_inc
	move.w	#rgb_delay,rgb_counter
.enhance	subq.w	#1,rgb_counter
	bpl.s	.past
	move.w	#rgb_delay,rgb_counter
	cmp.w	#4,pal_inc
	beq.s	.past
	add.w	#1,pal_inc

.past	move.w	pal_inc,d3
	move.w	xpos,d0
	move.w	red_palette_sprite+4,d1
	move.w	buffer_red,d2
	cmp.w	d1,d0
	bgt.s	.up
	cmp.w	#0,d2
	beq.s	.set
	sub.w	d3,buffer_red
	tst.w	buffer_red
	bpl.s	.set	
	move.w	#0,buffer_red
	bra.s	.set
.up	add.w	d3,buffer_red	
	cmp.w	#255,buffer_red
	ble.s	.set
	move.w	#255,buffer_red
.set	move.w	buffer_red,d0
	lsr.w	#2,d0
	add.w	#201,d0
	move.w	d0,red_palette_sprite+4
	bsr	set_buffer_newcol
do_red_stuff
	move.w	buffer_red,d0
	lsr.w	#2,d0
	add.w	#201,d0
	move.w	d0,red_palette_sprite
fuckred
	lea	red_palette_sprite,a1
	lea	palette_sprite1,a0
	bsr	set_palette_rgb

	move.l	#palette_sprite1,d0
	lea	palette_sprites+8,a0
	move.w	d0,6(a0)
	swap	d0
	move.w	d0,2(a0)

	move.l	#1,tcol
	move.l	#68,d0
	move.l	#33,d1
	moveq.l	#3,d3
	moveq.l	#0,d2
	move.w	buffer_red,d2
	bsr	dec_print
	rts
;---------------------------------------------
do_rgb_green
	cmp.w	#1,menu_sel
	beq.s	.enhance
	move.w	#1,menu_sel
	move.w	#1,pal_inc
	move.w	#rgb_delay,rgb_counter
.enhance	subq.w	#1,rgb_counter
	bpl.s	.past
	move.w	#rgb_delay,rgb_counter
	cmp.w	#4,pal_inc
	beq.s	.past
	add.w	#1,pal_inc

.past	move.w	pal_inc,d3
	move.w	xpos,d0
	move.w	green_palette_sprite+4,d1
	move.w	buffer_green,d2
	cmp.w	d1,d0
	bgt.s	.up
	cmp.w	#0,d2
	beq.s	.set
	sub.w	d3,buffer_green
	tst.w	buffer_green
	bpl.s	.set	
	move.w	#0,buffer_green
	bra.s	.set
.up	add.w	d3,buffer_green	
	cmp.w	#255,buffer_green
	ble.s	.set
	move.w	#255,buffer_green
.set	move.w	buffer_green,d0
	lsr.w	#2,d0
	add.w	#201,d0
	move.w	d0,green_palette_sprite+4
	bsr	set_buffer_newcol
do_green_stuff
	move.w	buffer_green,d0
	lsr.w	#2,d0
	add.w	#201,d0
	move.w	d0,green_palette_sprite
fuckgreen
	lea	green_palette_sprite,a1
	lea	palette_sprite2,a0
	bsr	set_palette_rgb

	move.l	#palette_sprite2,d0
	lea	palette_sprites+24,a0
	move.w	d0,6(a0)
	swap	d0
	move.w	d0,2(a0)

	move.l	#1,tcol
	move.l	#68,d0
	move.l	#41,d1
	moveq.l	#3,d3
	moveq.l	#0,d2
	move.w	buffer_green,d2
	bsr	dec_print
	rts
;---------------------------------------------
do_rgb_blue
	cmp.w	#2,menu_sel
	beq.s	.enhance
	move.w	#2,menu_sel
	move.w	#1,pal_inc
	move.w	#rgb_delay,rgb_counter
.enhance	subq.w	#1,rgb_counter
	bpl.s	.past
	move.w	#rgb_delay,rgb_counter
	cmp.w	#4,pal_inc
	beq.s	.past
	add.w	#1,pal_inc

.past	move.w	pal_inc,d3
	move.w	xpos,d0
	move.w	blue_palette_sprite+4,d1
	move.w	buffer_blue,d2
	cmp.w	d1,d0
	bgt.s	.up
	cmp.w	#0,d2
	beq.s	.set
	sub.w	d3,buffer_blue
	tst.w	buffer_blue
	bpl.s	.set	
	move.w	#0,buffer_blue
	bra.s	.set
.up	add.w	d3,buffer_blue	
	cmp.w	#255,buffer_blue
	ble.s	.set
	move.w	#255,buffer_blue
.set	move.w	buffer_blue,d0
	lsr.w	#2,d0
	add.w	#201,d0
	move.w	d0,blue_palette_sprite+4
	bsr	set_buffer_newcol
do_blue_stuff
	move.w	buffer_blue,d0
	lsr.w	#2,d0
	add.w	#201,d0
	move.w	d0,blue_palette_sprite
fuckblue
	lea	blue_palette_sprite,a1
	lea	palette_sprite3,a0
	bsr	set_palette_rgb

	move.l	#palette_sprite3,d0
	lea	palette_sprites+40,a0
	move.w	d0,6(a0)
	swap	d0
	move.w	d0,2(a0)

	move.l	#1,tcol
	move.l	#68,d0
	move.l	#48,d1
	moveq.l	#3,d3
	moveq.l	#0,d2
	move.w	buffer_blue,d2
	bsr	dec_print
	rts
;---------------------------------------------
print_bottom_select_rgb
	move.w	editpal,d0
	move.l	palette_list,a0
	move.l	(a0,d0.w*4),a0

	move.w	editbotcol,d0
	mulu	#3,d0
	move.b	(a0,d0.w),bottom_red+1
	move.b	1(a0,d0.w),bottom_green+1
	move.b	2(a0,d0.w),bottom_blue+1

	move.l	#1,tcol
	move.l	#73,d0
	move.l	#33,d1
	moveq.l	#3,d3
	moveq.l	#0,d2
	move.w	bottom_red,d2
	bsr	dec_print
	move.l	#73,d0
	move.l	#41,d1
	moveq.l	#3,d3
	moveq.l	#0,d2
	move.w	bottom_green,d2
	bsr	dec_print
	move.l	#73,d0
	move.l	#48,d1
	moveq.l	#3,d3
	moveq.l	#0,d2
	move.w	bottom_blue,d2
	bsr	dec_print
	rts
;---------------------------------------------
red_palette_sprite
	dc.w	80,231,0
green_palette_sprite
	dc.w	180,239,0
blue_palette_sprite
	dc.w	180,247,0

bottom_red		dc.w	0
bottom_green	dc.w	0
bottom_blue	dc.w	0
rgb_counter	dc.w	0
menu_sel		dc.w	0
pal_inc		dc.w	1
buffer_red		dc.w	0
buffer_green	dc.w	0
buffer_blue	dc.w	0
