

* Help Functions File. Contains code for all of the Help
* Requester enactment.

* These two pieces of code are branched to by all callers with the
* following data in the following registers:

* ptr to texts in A0
* no of text lines in D0

* First code calls up an InfoRequester, second calls up a
* QueryRequester & returns D0=0 if 'NO' gadget pressed, D0 = -1.W
* if 'YES' gadget pressed (Z flag in CCR conditioned also).


_PopUpIR		lea	IRT_1(pc),a1
		move.l	a1,irt_itext(a6)
		move.l	a0,irt_tlist(a6)
		move.w	d0,irt_count(a6)
		
		bsr	LinkInfoText

		bsr	ShowInfoReq

		rts


_PopUpQR		lea	QRT_1(pc),a1
		move.l	a1,irt_itext(a6)
		move.l	a0,irt_tlist(a6)
		move.w	d0,irt_count(a6)
		
		bsr	LinkInfoText

		bsr	DoQueryReq

		btst	#6,applic_flag2(a6)	;which gadget pressed?
		sne	d0			;d0=0 if NO pressed
		ext.w	d0			;else -1.W if YES

		rts


* This lot attached to the scroll gadgets.


SGHelp		btst	#1,applic_flag2(a6)	;HELP on?
		beq.s	SGH_Doit			;Exit if so

		lea	Help_GG1(pc),a0
		moveq	#7,d0
		bra.s	_PopUpIR
		moveq	#0,d0		;prevent execution of function

		rts			;and return

SGH_Doit		moveq	#-1,d0		;allow execution if not
		rts			;HELP on.


* This one attached to the Edit Switch.


EdSwHelp		btst	#1,applic_flag2(a6)	;HELP on?
		beq.s	EdSwH_Doit		;Exit if so

		lea	Help_EdSw(pc),a0

		moveq	#6,d0
		bra.s	_PopUpIR			;show help panel

EdSwH_Doit	moveq	#0,d0
		rts



